using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Input;
using Buddy.Coroutines;
using Clio.Utilities;
using ff14bot.AClasses;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.NeoProfiles;
using ff14bot.Objects;
using ff14bot.Pathing;
using ff14bot.Pathing.Service_Navigation;
using ff14bot.RemoteAgents;
using ff14bot.RemoteWindows;
using TreeSharp;
using Action = TreeSharp.Action;

namespace ExtractBot
{

    public class ExtractBot : AsyncBotBase
    {
        public override string Name => "ExtractBot";

        public override bool RequiresProfile => false;

        public override PulseFlags PulseFlags => PulseFlags.All;

        public override async Task AsyncRoot()
        {
            var validItems = InventoryManager.FilledInventoryAndArmory.Where(r => r.SpiritBond >= 100f && r.Item.ItemLevel >= 400);
            foreach (var item in validItems)
            {
                await CommonTasks.ConvertToMateria(item);
            }

        }

        public override Composite Root => null;

        public override void Start()
        {
            Navigator.NavigationProvider = new ServiceNavigationProvider();
            Navigator.PlayerMover = new SlideMover();
        }

        public override void Stop()
        {
            (Navigator.NavigationProvider as IDisposable)?.Dispose();
            Navigator.NavigationProvider = null;
        }
    }

}
